/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.factory.tracker;

import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Map;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleEvent;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.entaxy.platform.base.support.JSONUtils;
import ru.entaxy.platform.base.support.osgi.tracker.UniformBundleTrackerCustomizer;

public class TrackedFactoryCustomizer extends UniformBundleTrackerCustomizer<TrackedFactoryContainer> {

	private static final Logger log = LoggerFactory.getLogger(TrackedFactoryCustomizer.class);
	
	private static final String FACTORY_ROOT_PATH = "/ru/entaxy/factory/";
	
	@Override
	protected TrackedFactoryContainer createManagedObject(Bundle bundle, BundleEvent event,
			Map<String, List<?>> filterResults) {
		
		TrackedFactoryContainer result = new TrackedFactoryContainer(bundle);
		result.reload();
		return result;
/*		
		List<TrackedFactory> result = new ArrayList<>();
		
		Enumeration<URL> entries = bundle.findEntries(FACTORY_ROOT_PATH, "*.json", true);
		while (entries.hasMoreElements()) {
			URL entry = entries.nextElement();
			String urlString = entry.toString();
			log.debug("Found path: " + urlString);
			if (urlString.endsWith("/"))
				continue;
			String id = urlString.substring(urlString.lastIndexOf("/") + 1);
			id = id.substring(0, id.lastIndexOf("."));
			log.debug("Found id: " + id);
			
			try {
				String config = JSONUtils.getJsonRootObjectString(entry);
				TrackedFactory tf = new TrackedFactory();
				tf.setId(id);
				tf.setBundle(bundle);
				tf.setConfigString(config);
				result.add(tf);
			} catch (Exception e) {
				log.error("Error reading url: " + urlString, e);
			}
		}
		
		return result;
*/
	}

	
	
}
